"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotFrameworkAttachmentCustomActions = void 0;
const adaptive_expressions_1 = require("adaptive-expressions");
const botbuilder_dialogs_1 = require("botbuilder-dialogs");
const botframework_connector_1 = require("botframework-connector");
const attachmentActions_1 = require("./actions/attachmentActions");
class BotFrameworkAttachmentCustomActions extends botbuilder_dialogs_1.Dialog {
    constructor() {
        super(...arguments);
        this.url = new adaptive_expressions_1.StringExpression('');
        this.contentType = new adaptive_expressions_1.StringExpression('');
        this.action = new adaptive_expressions_1.StringExpression('');
        this.channelId = new adaptive_expressions_1.StringExpression('');
        this.msAppId = new adaptive_expressions_1.StringExpression('');
        this.msAppPwd = new adaptive_expressions_1.StringExpression('');
    }
    getConverter(property) {
        switch (property) {
            case "url":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "contentType":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "action":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "channelId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppPwd":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "resultProperty":
                return new adaptive_expressions_1.StringExpressionConverter();
            default:
                return super.getConverter(property);
        }
    }
    beginDialog(dc) {
        return __awaiter(this, void 0, void 0, function* () {
            const action = this.action.getValue(dc.state);
            let result;
            let debugStr = "|| 1 || ";
            try {
                if (action === 'GET_BASE64_CONTENT') {
                    let token = '';
                    let url = this.url.getValue(dc.state), urlStr = "";
                    if (typeof url !== "string") {
                        urlStr = JSON.stringify(url);
                    }
                    else {
                        urlStr = url;
                    }
                    debugStr = debugStr + " || 1.1 ||";
                    const channelId = this.channelId.getValue(dc.state);
                    debugStr = debugStr + " || 2 || channelId: " + channelId;
                    if (channelId == 'msteams' || channelId == 'skype') {
                        debugStr = debugStr + " || 3 || app id: " + this.msAppId.getValue(dc.state);
                        const credentials = new botframework_connector_1.MicrosoftAppCredentials(this.msAppId.getValue(dc.state), this.msAppPwd.getValue(dc.state));
                        debugStr = debugStr + " || 3.1 || b4 getToken!";
                        token = yield credentials.getToken(false);
                    }
                    debugStr = debugStr + " || 4 || urlStr: " + urlStr;
                    result = yield attachmentActions_1.AttachmentActions.getBase64Content(urlStr, this.contentType.getValue(dc.state), token);
                }
                debugStr = debugStr + " || 5 || b4 resultProperty";
                if (this.resultProperty) {
                    dc.state.setValue(this.resultProperty.getValue(dc.state), result);
                }
            }
            catch (error) {
                let errorText = "Unknown"; // error under useUnknownInCatchVariables 
                if (typeof error === "string") {
                    errorText = error.toUpperCase(); // works, `e` narrowed to string
                }
                else if (error instanceof Error) {
                    errorText = error.message; // works, `e` narrowed to Error
                }
                if (this.resultProperty) {
                    dc.state.setValue(this.resultProperty.getValue(dc.state), JSON.stringify({
                        "status": "FAILED-1",
                        "url": this.url.getValue(dc.state),
                        "error": errorText,
                        "debugLog": debugStr
                    }));
                }
            }
            return dc.endDialog(result);
        });
    }
    onComputeId() {
        return "BotbuilderSamples.BotFrameworkAttachmentCustomActions";
    }
}
exports.BotFrameworkAttachmentCustomActions = BotFrameworkAttachmentCustomActions;
BotFrameworkAttachmentCustomActions.$kind = "BotbuilderSamples.BotFrameworkAttachmentCustomActions";
